//----------------------------------------------------------------------//
// bZ[W															//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <System.StrUtils.hpp>
#include "usr_str.h"
#include "usr_msg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
//bZ[W̎擾
//---------------------------------------------------------------------------
UnicodeString LoadUsrMsg(int id, UnicodeString s)
{
	std::unique_ptr<TStringList> msg_lst(new TStringList());
	msg_lst->Text =
		"1001=%s܂B\n"							//USTR_NotFound
		"1002=%s̑ɂ͑ΉĂ܂B\n"				//USTR_OpeNotSuported
		"1003=̑͂ł܂B\n"							//USTR_CantOperate
		"1004=ΉĂȂ`łB\n"						//USTR_FmtNotSuported
		"1005=ꎞ𓀂Ɏs܂B\n"						//USTR_FaildTmpUnpack
		"1006=ړ悪łB\n"								//USTR_SameMoveDest
		"1007=Rs[悪łB\n"							//USTR_SameCopyDest
		"1008=fBNg܂܂Ă܂B\n"					//USTR_IncludeDir
		"1009=fBNgɃANZXł܂B\n"				//USTR_CantAccessDir
		"1010=sȓt܂͎łB\n"						//USTR_IllegalDate
		"1011=sȎwłB\n"								//USTR_IllegalParam
		"1012=sȌ`łB\n"								//USTR_IllegalFormat
		"1013=sȃAhXł\n"								//USTR_IllegalAddress
		"1014=NɎs܂B\n"							//USTR_FaildExec
		"1015=Ɏs܂B\n"							//USTR_FaildProc
		"1016=ǂݍ݂Ɏs܂B\n"						//USTR_FaildLoad
		"1017=%s̕ۑɎs܂B\n"						//USTR_FaildSave
		"1018=폜Ɏs܂B\n"							//USTR_FaildDelete
		"1019=Rs[Ɏs܂B\n"							//USTR_FaildCopy
		"1020=j[sł܂B\n"						//USTR_FaildMenu
		"1021=f܂B\n"									//USTR_Canceled
		"1022=[NXgJ܂B\n"						//USTR_WlistCantOpen
		"1023=ɂ̑͂ł܂B\n"					//USTR_ProcBusy
		"1024=Ώۂ܂B\n"								//USTR_NoObject
		"1025=K\Ɍ肪܂B\n"						//USTR_IllegalRegEx
		"1026=̓\n"								//USTR_InputFmtStr
		"1027=łɓo^Ă܂B\n"						//USTR_Registered
		"1028=@...^@ESCL[Œf܂B\n"			//USTR_SearchingESC
		"1029=@vZ...^@ESCL[Œf܂B\n"			//USTR_CalculatingESC
		"1030=@...^@ESCL[Œf܂B\n"			//USTR_ProcessingESC
		"1031=@...^@΂炭B\n"		//USTR_WaitForReady
		"1032=X|Xt@C̍쐬Ɏs܂B\n"		//USTR_FaildListFile
		"1033=ꎞfBNg쐬ł܂B\n"				//USTR_CantMakeTmpDir
		"1034=sȍ\łB\n"								//USTR_SyntaxError
		"1035=Ή鐧䕶܂B\n"				//USTR_BadStatmet
		"1036=p[^w肳Ă܂B\n"				//USTR_NoParameter
		"1037=AvP[V܂B\n"				//USTR_AppNotFound
		"1038=摜̏łĂ܂B\n"					//USTR_ImgNotReady
		"1039=t@CJ܂B\n"							//USTR_FileNotOpen
		"1040=fBNg܂B\n"					//USTR_DirNotFound
		"1041=ȃR}hłB\n"							//USTR_InvalidCmd
		"1042=. ŋ؂ĕw\\n"						//USTR_HintMltFExt
		"1043=; ŋ؂ĕw\\n"						//USTR_HintMltSepSC
		"1044=ΉGfB^܂\n"					//USTR_NoEditor
		"1045=Đł܂B\n"								//USTR_CantPlay
		"1046=%sɖOtĕۑ\n"							//USTR_SaveAs
		"1047=fBNg[%s]쐬ł܂B\n"				//USTR_CantCreDir
		"1048=%sRs[܂?\n"							//USTR_CopyQ
		"1049=%s폜܂?\n"								//USTR_DeleteQ
		"1050=%sS폜܂?\n"							//USTR_CompDeleteQ
		"1051=%sׂ̗č폜܂?\n"					//USTR_DelHistoryQ
		"1052=ׂĂ̏ꏊׂ̂Ẵ}[N܂?\n"	//USTR_ClrAllMarkQ
		"1053=R}h𒆒f܂?\n"						//USTR_CancelCmdQ
		"1054=A[JCuJ܂B\n"						//USTR_ArcNotOpen
		"1055=eLXgt@Cł͂܂B\n"				//USTR_NotText
		"1056=%s𒊏o܂?\n"								//USTR_Extract
		"1057=%s񂪎擾ł܂B\n"						//USTR_CantGetInfo
		"1058=OdĂ܂B\n"							//USTR_DuplicateName
		"1059=㏑Ă悢ł?\n"						//USTR_OverwriteQ
		"1060=%sAbv[h܂?\n"						//USTR_UploadQ
		"1061=%s_E[h܂?\n"						//USTR_DownloadQ
		"1062=폜Jn  %s\n"									//USTR_BeginDelete
		"1063=t@C̏ <%s>\n"						//USTR_SameName
		"1064=O̕ύX\n"										//USTR_Rename
		"1065=fBNg̈قȂ铯Ώۂ݂܂B\n"	//USTR_NgSameName
		"1066=sȓtłB\n"							//USTR_IllegalDtCond
		"1067=I}XÑ[NXg͕ύXł܂B\n"	//USTR_WorkFiltered
		"1068=EfBNgłB\n"					//USTR_SameDirLR
		"1069=Git̍ƃfBNgł͂܂B\n"			//USTR_NotRepository
		"1070=ݒplB\n"								//USTR_HideOptPanel
		"1071=ݒpl\\n"								//USTR_ShowOptPanel
		"1072=%s R}hŕύX\\n"							//USTR_OptCmdHint

		"1100=I\n"										//USTR_SelectedItem
		"1101=ꗗ\n"											//USTR_List
		"1102=Abv[h\n"									//USTR_Upload
		"1103=_E[h\n";									//USTR_Download

	UnicodeString ret_str = ReplaceStr(msg_lst->Values[IntToStr(id)], "^", "\r\n");
	ret_str = s.IsEmpty()? replace_regex(ret_str, _T("%s[̂]?"), null_TCHAR) : ReplaceStr(ret_str, "%s", s);
	return ret_str;
}
//---------------------------------------------------------------------------
UnicodeString LoadUsrMsg(int id, const _TCHAR *s)
{
	return LoadUsrMsg(id, UnicodeString(s));
}
//---------------------------------------------------------------------------
UnicodeString LoadUsrMsg(int id, int id_s)
{
	return LoadUsrMsg(id, LoadUsrMsg(id_s));
}

//---------------------------------------------------------------------------
//[U`bZ[W EAbort 𑗏o
//---------------------------------------------------------------------------
void UserAbort(unsigned id)
{
	throw EAbort(LoadUsrMsg(id));
}

//---------------------------------------------------------------------------
void SysErrAbort(unsigned id)
{
	throw EAbort(SysErrorMessage(id));
}
//---------------------------------------------------------------------------
void LastErrAbort()
{
	throw EAbort(SysErrorMessage(GetLastError()));
}
//---------------------------------------------------------------------------
void TextAbort(const _TCHAR *msg)
{
	throw EAbort(UnicodeString(msg));
}
//---------------------------------------------------------------------------
void SkipAbort()
{
	throw EAbort("SKIP");
}
//---------------------------------------------------------------------------
void EmptyAbort()
{
	throw EAbort(EmptyStr);
}

//---------------------------------------------------------------------------
//mFbZ[W
//---------------------------------------------------------------------------
bool SureCopy;					//Rs[
bool SureMove;					//ړ
bool SureDelete;				//폜
bool SureUnPack;				//
bool SureExec;					//s
bool SureOther;					//̑
bool SureExit;					//I
bool SureCmpDel;				//S폜2xmF
bool SureWorkList;				//[NXg̍ēǂݍ

//---------------------------------------------------------------------------
